> For a complete page index, fetch https://docs.synthflow.ai/llms.txt. For full documentation content, fetch https://docs.synthflow.ai/llms-full.txt.

# Attach an action

POST https://api.synthflow.ai/v2/actions/attach
Content-Type: application/json



Reference: https://docs.synthflow.ai/api-reference/platform-api/actions/attach-action

## Authentication

- `Authorization` header (bearer token, required)

## Servers

- `https://api.synthflow.ai/v2` (Global, default)
- `https://api.us.synthflow.ai/v2` (United States)
- `https://api.eu.synthflow.ai/v2` (European Union)

## Request

### Body (application/json)

- `model_id` (string, required) — The ID of the agent you want to attach an action to.
- `actions` (list of string, optional) — To find an action's ID, go to its page in your Synthflow dashboard.
- `items` (list of object, optional) — Batch attach payload with per-action attachment configuration.
  - `action_id` (string, optional) — ID of the action to attach. Provide either `action_id` or `slug`.
  - `slug` (string, optional) — Slug of the action to attach. Provide either `action_id` or `slug`.
  - `attachment_type` (enum, optional, nullable, default: during) — When this action is available in the conversation. Optional and defaults to `during` when omitted or null.
    - Allowed values: `before`, `during`, `after`
  - `trigger_condition` (string, optional, nullable) — Per-assistant 'When to use this Action' condition describing when the agent should call this action. Currently applies to custom actions. Omit or send null to leave it unchanged; send an empty string to clear it.
  - `input_variables_mapping` (list of object, optional) — Per-assistant mapping for this action's input variables, matching `Input variables` on the agent's action settings in the dashboard. The variables themselves are defined on the action with `variables_during_the_call`.
    - `variable_name` (string, required) — Input variable name defined in the action.
    - `source` (enum, required) — Source used to populate the variable.
      - Allowed values: `llm`, `hardcoded`
    - `hardcoded_value` (string, optional, nullable) — Value used when source is `hardcoded`.
    - `llm_config` (object, optional, nullable)
      - `description` (string, optional, nullable) — Description of the variable.
      - `example` (string, optional, nullable) — Example of the variable.
      - `required` (boolean, optional, nullable) — Whether the variable is required.

## Response

### 200

200

- `status` (string, optional)
- `response` (object, optional)

## Examples

### Attach Action

**Request**

```json
{
  "model_id": "1726005822670x239735712159542050",
  "actions": [
    "1725993202345x493030233644494700"
  ]
}
```

**Response**

```json
{
  "status": "success",
  "response": {}
}
```

**SDK Code**

```python Attach Action
import requests

url = "https://api.synthflow.ai/v2/actions/attach"

payload = {
    "model_id": "1726005822670x239735712159542050",
    "actions": ["1725993202345x493030233644494700"]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```go Attach Action
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.synthflow.ai/v2/actions/attach"

	payload := strings.NewReader("{\n  \"model_id\": \"1726005822670x239735712159542050\",\n  \"actions\": [\n    \"1725993202345x493030233644494700\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Attach Action
require 'uri'
require 'net/http'

url = URI("https://api.synthflow.ai/v2/actions/attach")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"model_id\": \"1726005822670x239735712159542050\",\n  \"actions\": [\n    \"1725993202345x493030233644494700\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Attach Action
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.synthflow.ai/v2/actions/attach")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"model_id\": \"1726005822670x239735712159542050\",\n  \"actions\": [\n    \"1725993202345x493030233644494700\"\n  ]\n}")
  .asString();
```

```csharp Attach Action
using RestSharp;

var client = new RestClient("https://api.synthflow.ai/v2/actions/attach");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"model_id\": \"1726005822670x239735712159542050\",\n  \"actions\": [\n    \"1725993202345x493030233644494700\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Attach Action
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "model_id": "1726005822670x239735712159542050",
  "actions": ["1725993202345x493030233644494700"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.synthflow.ai/v2/actions/attach")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Attach Action With Input Variable Mapping

**Request**

```json
{
  "model_id": "12acc0ac-df2a-47af-afe3-e1aa4380a307",
  "items": [
    {
      "action_id": "8d389276-9e87-42bf-a84f-d7e257cebc70",
      "attachment_type": "during",
      "trigger_condition": "Call this action only when the caller asks to book an appointment.",
      "input_variables_mapping": [
        {
          "variable_name": "code",
          "source": "llm",
          "llm_config": {
            "description": "Collect the code from the user.",
            "example": "1234"
          }
        }
      ]
    }
  ]
}
```

**Response**

```json
{
  "status": "success",
  "response": {}
}
```

**SDK Code**

```python Attach Action With Input Variable Mapping
import requests

url = "https://api.synthflow.ai/v2/actions/attach"

payload = {
    "model_id": "12acc0ac-df2a-47af-afe3-e1aa4380a307",
    "items": [
        {
            "action_id": "8d389276-9e87-42bf-a84f-d7e257cebc70",
            "attachment_type": "during",
            "trigger_condition": "Call this action only when the caller asks to book an appointment.",
            "input_variables_mapping": [
                {
                    "variable_name": "code",
                    "source": "llm",
                    "llm_config": {
                        "description": "Collect the code from the user.",
                        "example": "1234"
                    }
                }
            ]
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```go Attach Action With Input Variable Mapping
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.synthflow.ai/v2/actions/attach"

	payload := strings.NewReader("{\n  \"model_id\": \"12acc0ac-df2a-47af-afe3-e1aa4380a307\",\n  \"items\": [\n    {\n      \"action_id\": \"8d389276-9e87-42bf-a84f-d7e257cebc70\",\n      \"attachment_type\": \"during\",\n      \"trigger_condition\": \"Call this action only when the caller asks to book an appointment.\",\n      \"input_variables_mapping\": [\n        {\n          \"variable_name\": \"code\",\n          \"source\": \"llm\",\n          \"llm_config\": {\n            \"description\": \"Collect the code from the user.\",\n            \"example\": \"1234\"\n          }\n        }\n      ]\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Attach Action With Input Variable Mapping
require 'uri'
require 'net/http'

url = URI("https://api.synthflow.ai/v2/actions/attach")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"model_id\": \"12acc0ac-df2a-47af-afe3-e1aa4380a307\",\n  \"items\": [\n    {\n      \"action_id\": \"8d389276-9e87-42bf-a84f-d7e257cebc70\",\n      \"attachment_type\": \"during\",\n      \"trigger_condition\": \"Call this action only when the caller asks to book an appointment.\",\n      \"input_variables_mapping\": [\n        {\n          \"variable_name\": \"code\",\n          \"source\": \"llm\",\n          \"llm_config\": {\n            \"description\": \"Collect the code from the user.\",\n            \"example\": \"1234\"\n          }\n        }\n      ]\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Attach Action With Input Variable Mapping
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.synthflow.ai/v2/actions/attach")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"model_id\": \"12acc0ac-df2a-47af-afe3-e1aa4380a307\",\n  \"items\": [\n    {\n      \"action_id\": \"8d389276-9e87-42bf-a84f-d7e257cebc70\",\n      \"attachment_type\": \"during\",\n      \"trigger_condition\": \"Call this action only when the caller asks to book an appointment.\",\n      \"input_variables_mapping\": [\n        {\n          \"variable_name\": \"code\",\n          \"source\": \"llm\",\n          \"llm_config\": {\n            \"description\": \"Collect the code from the user.\",\n            \"example\": \"1234\"\n          }\n        }\n      ]\n    }\n  ]\n}")
  .asString();
```

```csharp Attach Action With Input Variable Mapping
using RestSharp;

var client = new RestClient("https://api.synthflow.ai/v2/actions/attach");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"model_id\": \"12acc0ac-df2a-47af-afe3-e1aa4380a307\",\n  \"items\": [\n    {\n      \"action_id\": \"8d389276-9e87-42bf-a84f-d7e257cebc70\",\n      \"attachment_type\": \"during\",\n      \"trigger_condition\": \"Call this action only when the caller asks to book an appointment.\",\n      \"input_variables_mapping\": [\n        {\n          \"variable_name\": \"code\",\n          \"source\": \"llm\",\n          \"llm_config\": {\n            \"description\": \"Collect the code from the user.\",\n            \"example\": \"1234\"\n          }\n        }\n      ]\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Attach Action With Input Variable Mapping
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "model_id": "12acc0ac-df2a-47af-afe3-e1aa4380a307",
  "items": [
    [
      "action_id": "8d389276-9e87-42bf-a84f-d7e257cebc70",
      "attachment_type": "during",
      "trigger_condition": "Call this action only when the caller asks to book an appointment.",
      "input_variables_mapping": [
        [
          "variable_name": "code",
          "source": "llm",
          "llm_config": [
            "description": "Collect the code from the user.",
            "example": "1234"
          ]
        ]
      ]
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.synthflow.ai/v2/actions/attach")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```